"""
model classes for EDI@Energy API-Webdienste zur Ermittlung der MaLo-ID der Marktlokation
"""

# In this module we just re-export the _autogenerated classes, but we might - in the future - fix them or provide better
# suited models, e.g. by using proper datetime types instead of regex-constrained strings.
# As of now, any fixes to the broken openapi.yml happen in the yaml itself, i.e. BEFORE the code generation.

from ._autogenerated import (
    Address,
    City,
    Company,
    CountryCode,
    CreationDateTime,
    CustomerNumber,
    DataControllableResource,
    DataControllableResourceMeasuringPointOperators,
    DataControllableResources,
    DataMarketLocation,
    DataMarketLocationMeasuringPointOperators,
    DataMarketLocationNetworkOperators,
    DataMarketLocationProperties,
    DataMarketLocationSuppliers,
    DataMarketLocationTransmissionSystemOperators,
    DataMeterLocation,
    DataMeterLocationMeasuringPointOperators,
    DataMeterLocations,
    DataNetworkLocation,
    DataNetworkLocationMeasuringPointOperators,
    DataNetworkLocations,
    DataTechnicalResource,
    DataTechnicalResources,
    DataTranche,
    DataTranches,
    DataTrancheSuppliers,
    DecisionTree,
    DistrictName,
    East,
    Easting,
    EnergyDirection,
    ExecutionTimeFrom,
    ExecutionTimeUntil,
    Firstnames,
    GeographicCoordinates,
    HouseNumber,
    HouseNumberAddition,
    IdentificationDateTime,
    IdentificationParameter,
    IdentificationParameterIdentificationParameterAddress,
    IdentificationParameterIdentificationParameterId,
    InitialTransactionId,
    LandParcel,
    LandParcels,
    Latitude,
    Longitude,
    LotNumber,
    MaloId,
    MarketLocationDateTime,
    MarketLocationDateTimes,
    MarketLocationMeasuringPointOperator,
    MarketLocationNetworkOperator,
    MarketLocationProperties,
    MarketLocationProperty,
    MarketLocationSupplier,
    MarketLocationTransmissionSystemOperator,
    MarketPartnerId,
    MeasurementTechnologyClassification,
    MeloId,
    MeloIds,
    MeterLocationMeasuringPointOperator,
    MeterNumber,
    MeterNumbers,
    Name,
    NeloId,
    NetworkLocationMeasuringPointOperator,
    North,
    Northing,
    OptionalChangeForecastBasis,
    Percent,
    Proportion,
    Reason,
    ReferenceId,
    ResponseCode,
    ResultNegative,
    ResultPositive,
    SrId,
    SrMarketPartner,
    Street,
    SubLotNumber,
    Surnames,
    Title,
    TranchenId,
    TranchenIds,
    TrancheSupplier,
    TransactionId,
    TrId,
    ZipCode,
    Zone,
)

__all__ = [
    "Address",
    "City",
    "Company",
    "CountryCode",
    "CreationDateTime",
    "CustomerNumber",
    "DataControllableResource",
    "DataControllableResourceMeasuringPointOperators",
    "DataControllableResources",
    "DataMarketLocation",
    "DataMarketLocationMeasuringPointOperators",
    "DataMarketLocationNetworkOperators",
    "DataMarketLocationProperties",
    "DataMarketLocationSuppliers",
    "DataMarketLocationTransmissionSystemOperators",
    "DataMeterLocation",
    "DataMeterLocationMeasuringPointOperators",
    "DataMeterLocations",
    "DataNetworkLocation",
    "DataNetworkLocationMeasuringPointOperators",
    "DataNetworkLocations",
    "DataTechnicalResource",
    "DataTechnicalResources",
    "DataTranche",
    "DataTrancheSuppliers",
    "DataTranches",
    "DecisionTree",
    "DistrictName",
    "East",
    "Easting",
    "EnergyDirection",
    "ExecutionTimeFrom",
    "ExecutionTimeUntil",
    "Firstnames",
    "GeographicCoordinates",
    "HouseNumber",
    "HouseNumberAddition",
    "IdentificationDateTime",
    "IdentificationParameter",
    "IdentificationParameterIdentificationParameterAddress",
    "IdentificationParameterIdentificationParameterId",
    "InitialTransactionId",
    "LandParcel",
    "LandParcels",
    "Latitude",
    "Longitude",
    "LotNumber",
    "MaloId",
    "MarketLocationDateTime",
    "MarketLocationDateTimes",
    "MarketLocationMeasuringPointOperator",
    "MarketLocationNetworkOperator",
    "MarketLocationProperties",
    "MarketLocationProperty",
    "MarketLocationSupplier",
    "MarketLocationTransmissionSystemOperator",
    "MarketPartnerId",
    "MeasurementTechnologyClassification",
    "MeloId",
    "MeloIds",
    "MeterLocationMeasuringPointOperator",
    "MeterNumber",
    "MeterNumbers",
    "Name",
    "NeloId",
    "NetworkLocationMeasuringPointOperator",
    "North",
    "Northing",
    "OptionalChangeForecastBasis",
    "Percent",
    "Proportion",
    "Reason",
    "ReferenceId",
    "ResponseCode",
    "ResultNegative",
    "ResultPositive",
    "SrId",
    "SrMarketPartner",
    "Street",
    "SubLotNumber",
    "Surnames",
    "Title",
    "TrId",
    "TrancheSupplier",
    "TranchenId",
    "TranchenIds",
    "TransactionId",
    "ZipCode",
    "Zone",
]
